package dicewars.test;

import dicewars.model.Hex;
import dicewars.util.Point;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;

import javafx.stage.Stage;

import java.util.ArrayList;
import java.util.List;

import static java.lang.System.out;

/*
        Some things are hard to test.
        If just getting a lot of numerical data not possible to recognize,
        possible better (have to) to do some visual testing.

        This is visual testing of conversion between cartesian coordinates
        and hex coordinates..

        Nothing to do here!

 */
public class TestHex extends Application {

    private GraphicsContext gc;

    private void mouseListener(MouseEvent me) {
        out.println(me.getX() + ":" + me.getY());
        Hex h = new Hex(new Point(me.getX(), me.getY()), 50);
        out.println(h);

    }

    private void mouseMoveListener(MouseEvent me) {
        //Hex h = new Hex( new Point(me.getX(), me.getY()), 50);
        //out.println(h);
    }

    List<Hex> hexes = new ArrayList<>();

    @Override
    public void init() {
        hexes.add(new Hex(0, 0));
        hexes.add(new Hex(1, 0));
        hexes.add(new Hex(2, 0));
        hexes.add(new Hex(0, 1));
        hexes.add(new Hex(1, 1));
        hexes.add(new Hex(2, 1));
        hexes.add(new Hex(0, 2));
        hexes.add(new Hex(1, 2));
        hexes.add(new Hex(2, 2));
    }

    @Override
    public void start(Stage primaryStage) throws Exception {
        BorderPane root = new BorderPane();
        root.setOnMouseClicked(this::mouseListener);
        root.setOnMouseMoved(this::mouseMoveListener);

        Canvas canvas = new Canvas(400, 400);
        gc = canvas.getGraphicsContext2D();
        root.setCenter(canvas);
        renderHexes(hexes);

        Scene scene = new Scene(root);
        primaryStage.setScene(scene);
        primaryStage.setTitle("Test Hex");
        primaryStage.show();
    }

    private void renderHexes(List<Hex> hexes) {
        double[] xs = new double[6];
        double[] ys = new double[6];

        for (Hex h : hexes) {
            List<Point> corners = h.getCorners(50);
            getXsAndYs(xs, ys, corners);
            gc.strokePolygon(xs, ys, xs.length);
            Point p = h.toPoint(50);
            gc.fillOval(p.x + margin, p.y + margin, 2, 2);
        }
    }

    private double margin = 0;

    // Conversion from list of Points to parallel arrays of x and y -coordinates
    private void getXsAndYs(double[] xs, double[] ys, List<Point> pts) {
        int i = 0;
        for (Point p : pts) {
            xs[i] = p.x + margin;
            ys[i] = p.y + margin;
            i++;
        }
    }

    public static void main(String[] args) {
        launch();
    }

}
