package samples.catchtherain;

import java.awt.*;

/**
 * A bucket for CatchTheRain
 */

public class Bucket {
    private final Color color;
    private final double dx;
    private final double width;
    private final double height;
    private double x;   // Left
    private final double y;   // Top

    public Bucket(double x, double y, double width, double height, double dx, Color color) {
        this.x = x;
        this.y = y;
        this.dx = dx;
        this.width = width;
        this.height = height;
        this.color = color;
    }

    public void right() {
        x += dx;
    }

    public void left() {
        x -= dx;
    }

    public Rectangle getBoundingBox() {
        int x = (int) (this.x);
        int y = (int) (this.y);
        int h = (int) height;
        int w = (int) width;
        return new Rectangle(x, y, w, h);
    }

    public double getX() {
        return x;
    }

    public double getWidth() {
        return width;
    }

    public double getHeight() {
        return height;
    }

    public Color getColor() {
        return color;
    }

    public double getY() {
        return y;
    }
}