package exercises.ex4hangman;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

import static java.lang.System.*;

/*
 *  The very well known Hangman game (in a text version)
 *  This is the main program i.e. game logic and the text based IO.
 *
 *  Run this to run the game
 *
 */
public class HangMan {

    public static void main(String[] args) {
        new HangMan().program();
    }

    private final Scanner sc = new Scanner(in);
    private final Random rand = new Random();

    // Parts of the hanging man (\n is the new line character)
    private final String[] parts = {
            "---|\n",
            "   |\n",
            "   O\n",
            "  /",
            "|",
            "\\\n",   // This is \\ (2 backslash) and a new line (= escaping), see web
            "  /",
            " \\\n",
    };

    private int nGuess = 0;
    private Result result;

    private void program() {
        List<String> words;
        try {
            Path path = Paths.get("src/exercises/ex4hangman/words.txt");
            words = FileService.readFile(path);
        } catch (IOException e) {
            out.println(e.getMessage());
            return;
        }


        // TODO Game logic here
    }

    // ---- IO don't belong to other classes, put it here ---------------
    private char guessCharacter() {
        String input;
        while( true ){
            out.print("Enter a char > ");
            input = sc.nextLine();
            if( input.length() == 1 && Character.isLetter(input.charAt(0))){
                break;
            }
        }
        return input.charAt(0);
    }

    private void plotMask(String mask) {
        for (char ch : mask.toCharArray()) {
            out.print(ch + " ");
        }
        out.println();
    }

    private void plotMan(int nParts) {
        for( int i = 0  ; i < nParts ; i++){
            out.print(parts[i]);
        }
    }
}
