package exercises.oo.tictactoe;

import java.util.Arrays;
import java.util.Scanner;

import static exercises.oo.tictactoe.Board.N_COLS;
import static java.lang.System.in;
import static java.lang.System.out;

/*
        OO Implementation of command line game TicTacToe from week 1
        Implement it!

        Sample run

        Welcome to Tic Tac Toe, board is ...
        - - -
        - - -
        - - -
        Player is olle(X)
        Select row to put mark > 1
        Select col to put mark > 1
        [0, 0]
        X - -
        - - -
        - - -
        Player is pelle(O)
        Select row to put mark > 3
        Select col to put mark > 1
        [2, 0]
        X - -
        - - -
        O - -
        Player is olle(X)
        Select row to put mark >

 */

public class TicTacToe {

    public static void main(String[] args) {
        new TicTacToe().program();
    }

    private void program() {
        Player p1 = new Player("olle", 'X');
        Player p2 = new Player("pelle", 'O');
        Player winner = null;

        Board board = new Board();

        out.println("Welcome to Tic Tac Toe, board is ...");
        plotBoard(board);
        Player actual = p1;   // Bad, jus for now

        while (!board.isFull()) {

            // TODO Game loop
        }

        out.println("Game over!");
        plotBoard(board);
        if (winner == p2) {
            out.println("Winner is " + p2.getName());
        } else if (winner == p1) {
            out.println("Winner is " + p1.getName());
        } else {
            out.println("Draw");
        }
    }

    // --- Input/output  ------------------

    private int[] getPlayerSelection(Player player) {
        int[] rowCol = new int[2];
        out.println("Player is " + player.getName() + "(" + player.getMark() + ")");
        Scanner sc = new Scanner(in);
        while (true) {
            out.print("Select row to put mark > ");
            rowCol[0] = sc.nextInt() - 1;             // Adjust for zero based array
            out.print("Select col to put mark > ");
            rowCol[1] = sc.nextInt() - 1;            // Adjust for zero based array
            if (inRange(rowCol)) {
                return rowCol;
            }
        }
    }

    private boolean inRange(int[] rowCol) {
        return 0 <= rowCol[0] && rowCol[0] < N_COLS &&
                0 <= rowCol[1] && rowCol[1] < N_COLS;
    }

    private void plotBoard(Board b) {
        char[] ba = b.toArray();
        for (int i = 0; i < ba.length; i++) {
            out.print(ba[i] + " ");
            if ((i + 1) % N_COLS == 0) {
                out.println();
            }
        }
    }


}